import Vue from 'vue'
import Dialog from '../nav/dialog'
import Sheet from '../nav/sheet'
import Snackbar from '../nav/snackbar'
import Vuetify from 'vuetify'
// import colors from 'vuetify/lib/util/colors'

export default class {
  static dialog(properties) {
    if (!this.stack) {
      this.stack = []
    }

    // https://css-tricks.com/creating-vue-js-component-instances-programmatically/
    const DialogClass = Vue.extend(Dialog)
    const instance = new DialogClass({
      vuetify: new Vuetify({
        theme: {
          themes: Utils.settings.themes
        }
      }),
      propsData: { spec: properties }
    })
    // instance.spec = properties
    instance.stack = this.stack

    const placeholder = document.body.appendChild(document.createElement('div'))
    instance.$mount(placeholder)
  }

  static closeDialog(properties, target, component) {
    if (!this.stack) {
      this.stack = []
    }

    Utils.type.ifObject(this.stack.last(), dialog => {
      dialog.close()
    })

    Utils.type.ifObject(properties['onClose'], it => {
      Action.execute(it, target, component)
    })
  }

  static sheet(properties) {
    const SheetClass = Vue.extend(Sheet)
    const instance = new SheetClass({
      vuetify: new Vuetify({
        theme: {
          themes: Utils.settings.themes
        }
      }),
      propsData: { spec: properties }
    })
    // instance.spec = properties
    const placeholder = document.body.appendChild(document.createElement('div'))
    instance.$mount(placeholder)
    // instance.show = true
  }

  static snackbar(properties) {
    const SnackbarClass = Vue.extend(Snackbar)
    const instance = new SnackbarClass({
      vuetify: new Vuetify({
        theme: {
          themes: Utils.settings.themes
        }
      }),
      propsData: { spec: properties }
    })
    // instance.spec = properties

    const placeholder = document.body.appendChild(document.createElement('div'))
    instance.$mount(placeholder)
    instance.show = true
  }

  static confirmSheet(properties, onConfirm) {
    const spec = Object.assign({}, properties, {
      buttons: [
        // {
        //   text: 'Cancel',
        //   onClick: properties.onCancel
        // },
        {
          text: 'Confirm',
          onClickFunction: onConfirm
          // onClick: properties.onConfirm
        }
      ],
    })
    this.sheet(spec)
  }
}
